const mdx = require('@mdx-js/mdx')
const babel = require("@babel/core")
const fs = require('fs')
const path = require('path')
const RSS = require('rss')

function requireFromStringSync(src, filename) {
  const Module = module.constructor;
  const m = new Module();
  m._compile(src, filename);
  return m.exports;
}

function requireMDXSync(mdxSrc, filename) {
  const jsx = mdx.sync(mdxSrc)
  const babelOptions = babel.loadOptions({
    babelrc: false,
    presets: [
      '@babel/preset-react',
      // ^^^ mitigates error:
      // SyntaxError: unknown: Unexpected token (6:33)
      // > 6 | export default ({components}) => <MDXTag name="wrapper">{`
      //     |                                  ^
    ],
    plugins: [
      "@babel/plugin-transform-modules-commonjs",
      // ^^^ mitigages error:
      // hello.mdx:1
      // (function (exports, require, module, __filename, __dirname) { export const meta = {
      //                                                               ^^^^^^
      //      SyntaxError: Unexpected token export
    ]
  })
  const transformed = babel.transformSync(jsx, babelOptions)
  return requireFromStringSync(transformed.code, filename)
}

function requireMDXFileSync(path) {
  const mdxSrc = fs.readFileSync(path, { encoding: 'utf-8' })
  return requireMDXSync(mdxSrc, path)
}

function scanDir(dirPath, extension) {
  const mdxFiles = []
  const scan = (dirPath) => {
    const filenames = fs.readdirSync(dirPath)
    filenames.sort()
    filenames.map(filename => {
      const filePath = path.join(dirPath, filename)
      const st = fs.statSync(filePath)
      if (st.isFile() && filePath.endsWith(extension)) {
        mdxFiles.push(filePath)
      }
      if (st.isDirectory()) {
        scan(filePath)
      }
    })
  }
  scan(dirPath)
  return mdxFiles
}

function readPostMetadata(postPath) {
  const mod = requireMDXFileSync(postPath)
  const { meta } = mod
  return {
    filePath: postPath,
    urlPath: postPath.replace(/\\/, '/').replace(/^pages/, '').replace(/\.mdx?$/, ''),
    title: meta.title || path.basename(postPath),
    date: new Date(meta.date),
    description: meta.description
  }
}

function generateRSS(posts) {
  const siteUrl = 'https://nextjs-mdx-blog-example.now.sh'
  const feed = new RSS({
    title: 'My blog',
    site_url: siteUrl,
  })
  posts.map(post => {
    feed.item({
      title: post.title,
      guid: post.urlPath,
      url: siteUrl + post.urlPath,
      date: post.date,
      description: post.description,
    })
  })
  return feed.xml({ indent: true })
}

function main() {
  const postPaths = scanDir('pages', '.mdx')
  //console.debug({ postPaths })
  const now = new Date()
  const posts = postPaths
    .map(readPostMetadata)
    .filter(post => post.date <= now)
  posts.sort((a, b) => b.date - a.date)
  //console.debug({ posts })
  const postsJSON = JSON.stringify(posts, null, 2)
  const exportPath = 'posts.js'
  fs.writeFileSync(exportPath,
    '// automatically generated by build_post_index.js\n' +
    `export default ${postsJSON}\n`
  )
  console.info(`Saved ${posts.length} posts in ${exportPath}`)
  const rssPath = 'public/rss-feed.xml'
  const rssXML = generateRSS(posts)
  fs.writeFileSync(rssPath, rssXML)
  console.info(`Saved RSS feed to ${rssPath}`)
}

main()
